﻿package com.blazinggames.ootw.ep32
{
	// Adobe Imports
	import flash.display.Graphics;
	import flash.display.MovieClip;

	public class Charles
	extends MovieClip
	implements IBillboard
	{
// *********************
// ***** CONSTANTS *****
// *********************

		protected const DIROFFX:Array = new Array(0.0,1.0,0.0,-1.0);
		protected const DIROFFY:Array = new Array(-1.0,0.0,1.0,0.0);
		protected const WEIGHTS:Array = new Array(25 /*player*/, 
				30 /*ykcul*/, 40 /*squirrel*/);

// *********************
// ***** VARIABLES *****
// *********************

		public var billboardData:BillboardData;
		protected var _targetX:Number;
		protected var _targetY:Number;

// ***********************
// ***** CONSTRUCTOR *****
// ***********************

		public function Charles(nx:Number = 0, ny:Number = 0)
		{
			billboardData = new BillboardData();
			billboardData.setMapLocation(nx, ny);
			billboardData.setNearSize(300,600);
			_targetX = nx;
			_targetY = ny;
		}

// ******************************************
// ***** Function - Getters and Setters *****
// ******************************************

		public function getBillboardData():BillboardData
		{
			return billboardData;
		}

// ********************************
// ***** Functions - movement *****
// ********************************

		public function getDistanceSqr(x1:Number, y1:Number, 
				x2:Number, y2:Number):Number
		{
			var dx:Number = x1 - x2;
			var dy:Number = y1 - y2;
			return (dx*dx + dy*dy);
		}

		protected function findNewTarget(forest:Forest)
		{
			var weights:Array = new Array(4);
			var cntr:int, cntrChars:int;
			var t:int;
			var tempWeight:Number, tempX:Number, tempY:Number;
			var bestWeight = -10000000;
			var bestIndex = 0;
//			var trStr:String = "weights ";
			for (cntr = 0; cntr < 4; ++cntr) {
				tempX = _targetX + DIROFFX[cntr];
				tempY = _targetY + DIROFFY[cntr];
				t=forest.getTile(tempX, tempY);
				// make sure don't walk through trees
				tempWeight = t == forest.TILE_TREE ? -1000000 : 0;
				// add a slight bit of randomness to the decision
				tempWeight += Math.random() * 10;
				// the further from the various players the better
				for (cntrChars = 0; cntrChars < 3; ++cntrChars) {
					tempWeight -= (WEIGHTS[cntrChars] - 
							Math.min(getDistanceSqr(tempX, tempY,
							forest.getPlayerX(cntrChars), 
							forest.getPlayerY(cntrChars)),
							WEIGHTS[cntrChars]));
				}
//				trStr = trStr + " " + tempWeight;
				if (tempWeight > bestWeight) {
					bestIndex = cntr;
					bestWeight = tempWeight;
				}
			}
			_targetX += DIROFFX[bestIndex];
			_targetY += DIROFFY[bestIndex];
//			trace(trStr);
		}

		public function takeTurn(forest:Forest, secs:Number)
		{
			if (secs < .001) return;
			var dist:Number = forest.getDistance(_targetX, _targetY,
					billboardData.mapX, billboardData.mapY);
			if (dist < secs) {
				billboardData.mapX = _targetX;
				billboardData.mapY = _targetY;
				findNewTarget(forest);
				takeTurn(forest, secs - dist);
			} else {
				var distX = _targetX - billboardData.mapX;
				var distY = _targetY - billboardData.mapY;
				billboardData.mapY += (distY / dist * secs);
				billboardData.mapX += (distX / dist * secs);
			}
		}
	} // end class
} // end package

